Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QDialog

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QDialog

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

Direct Known Subclasses:
  QAbstractPageSetupDialog, QAbstractPrintDialog, QColorDialog, QErrorMessage, QFileDialog, QFontDialog, QInputDialog, QMessageBox, QPrintPreviewDialog, QProgressDialog, QWizard

    public class QDialog

extends QWidget

The `QDialog` class is the base class of dialog windows. A dialog window is a top-level window mostly used for short-term tasks and brief communications with the user. QDialogs may be modal or modeless. QDialogs can provide a `return value`, and they can have `default buttons`. QDialogs can also have a `QSizeGrip` in their lower-right corner, using `setSizeGripEnabled()`.

Note that `QDialog` (an any other widget that has type `Qt::Dialog` ) uses the parent widget slightly differently from other classes in Qt. A dialog is always a top-level widget, but if it has a parent, its default location is centered on top of the parent's top-level widget (if it is not top-level itself). It will also share the parent's taskbar entry.

Use the overload of the `QWidget::setParent()` function to change the ownership of a `QDialog` widget. This function allows you to explicitly set the window flags of the reparented widget; using the overloaded function will clear the window flags specifying the window-system properties for the widget (in particular it will reset the `Qt::Dialog` flag).

## Modal Dialogs

A modal dialog is a dialog that blocks input to other visible windows in the same application. Dialogs that are used to request a file name from the user or that are used to set application preferences are usually modal. Dialogs can be `application modal` (the default) or `window modal` .

When an application modal dialog is opened, the user must finish interacting with the dialog and close it before they can access any other window in the application. Window modal dialogs only block access to the window associated with the dialog, allowing the user to continue to use other windows in an application.

The most common way to display a modal dialog is to call its `exec()` function. When the user closes the dialog, `exec()` will provide a useful `return value`. Typically, to get the dialog to close and return the appropriate value, we connect a default button, e.g. OK, to the `accept()` slot and a Cancel button to the `reject()` slot. Alternatively you can call the `done()` slot with `Accepted` or `Rejected`.

An alternative is to call setModal(true) or setWindowModality(), then `show()`. Unlike `exec()`, `show()` returns control to the caller immediately. Calling setModal(true) is especially useful for progress dialogs, where the user must have the ability to interact with the dialog, e.g. to cancel a long running operation. If you use `show()` and setModal(true) together to perform a long operation, you must call `QApplication::processEvents()` periodically during processing to enable the user to interact with the dialog. (See `QProgressDialog`.)

## Modeless Dialogs

A modeless dialog is a dialog that operates independently of other windows in the same application. Find and replace dialogs in word-processors are often modeless to allow the user to interact with both the application's main window and with the dialog.

Modeless dialogs are displayed using `show()`, which returns control to the caller immediately.

If you invoke the `show()` function after hiding a dialog, the dialog will be displayed in its original position. This is because the window manager decides the position for windows that have not been explicitly placed by the programmer. To preserve the position of a dialog that has been moved by the user, save its position in your `closeEvent()` handler and then move the dialog to that position, before showing it again.

## Default Button

A dialog's default button is the button that's pressed when the user presses Enter (Return). This button is used to signify that the user accepts the dialog's settings and wants to close the dialog. Use `QPushButton::setDefault()`, `QPushButton::isDefault()` and `QPushButton::autoDefault()` to set and control the dialog's default button.

## Escape Key

If the user presses the Esc key in a dialog, `QDialog::reject()` will be called. This will cause the window to close: The `close event` cannot be `ignored`.

## Extensibility

Extensibility is the ability to show the dialog in two ways: a partial dialog that shows the most commonly used options, and a full dialog that shows all the options. Typically an extensible dialog will initially appear as a partial dialog, but with a More toggle button. If the user presses the More button down, the dialog is expanded. The Extension Example shows how to achieve extensible dialogs using Qt.

## Return Value (Modal Dialogs)

Modal dialogs are often used in situations where a return value is required, e.g. to indicate whether the user pressed OK or Cancel. A dialog can be closed by calling the `accept()` or the `reject()` slots, and `exec()` will return `Accepted` or `Rejected` as appropriate. The `exec()` call returns the result of the dialog. The result is also available from `result()` if the dialog has not been destroyed.

In order to modify your dialog's close behavior, you can reimplement the functions `accept()`, `reject()` or `done()`. The `closeEvent()` function should only be reimplemented to preserve the dialog's position or to override the standard close or reject behavior.

## Code Examples

A modal dialog:

        void countWords()
        {
            WordCountDialog dialog = new WordCountDialog(this);
            dialog.setWordCount(document().wordCount());
            dialog.exec();
        }

A modeless dialog:

        void find()
        {
            if (findDialog == null) {
                findDialog = new FindDialog(this);
                findDialog.findNext.connect(this, "findNext()");
            }

            findDialog.show();
            findDialog.raise();
            findDialog.activateWindow();
        }

See also:
  `QDialogButtonBox`, `QTabWidget`, `QWidget`, `QProgressDialog`, GUI Design Handbook: Dialogs, Standard, Extension Example, and Standard Dialogs Example.

Nested Class Summary
`static class` | `QDialog.DialogCode` The value returned by a modal dialog.

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal0` | `accepted` This signal is emitted when the dialog has been accepted either by the user or by calling `accept()` or `done()` with the `QDialog::Accepted` argument.
`QSignalEmitter.Signal1` | `finished` This signal takes 1 generic argument(s).
`QSignalEmitter.Signal0` | `rejected` This signal is emitted when the dialog has been rejected either by the user or by calling `reject()` or `done()` with the `QDialog::Rejected` argument.

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QDialog()` Constructs a dialog with parent `parent`.
`QDialog(QWidget parent)` Constructs a dialog with parent `parent`.
`QDialog(QWidget parent, Qt.WindowFlags f)` Constructs a dialog with parent `parent`.
`QDialog(QWidget parent, Qt.WindowType[] f)` Constructs a dialog with parent `parent`.

Method Summary
`void` | `accept()` Hides the modal dialog and sets the result code to `Accepted`.
`void` | `done(int arg__1)` Closes the dialog and sets its result code to `r`.
`int` | `exec()` Shows the dialog as a `modal dialog`, blocking until the user closes it.
`boolean` | `isSizeGripEnabled()` This property holds whether the size grip is enabled.
`void` | `reject()` Hides the modal dialog and sets the result code to `Rejected`.
`int` | `result()` Returns the modal dialog's result code, `Accepted` or `Rejected`.
`void` | `setModal(boolean modal)` This property holds whether `show()` should pop up the dialog as modal or modeless.
`void` | `setResult(int r)` Sets the modal dialog's result code to `i`.
`void` | `setSizeGripEnabled(boolean arg__1)` This property holds whether the size grip is enabled.

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### accepted

    public final QSignalEmitter.Signal0 accepted

  This signal is emitted when the dialog has been accepted either by the user or by calling `accept()` or `done()` with the `QDialog::Accepted` argument.

  Note that this signal is not emitted when hiding the dialog with `hide()` or setVisible(false). This includes deleting the dialog while it is visible.

See also:
  `finished()` , and `rejected()` .

### finished

    public final QSignalEmitter.Signal1 finished

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Integer(named: result)>:

  This signal is emitted when the dialog's `result` code has been set, either by the user or by calling `done()`, `accept()`, or `reject()`.

  Note that this signal is not emitted when hiding the dialog with `hide()` or setVisible(false). This includes deleting the dialog while it is visible.

See also:
  `accepted()` , and `rejected()` .

### rejected

    public final QSignalEmitter.Signal0 rejected

  This signal is emitted when the dialog has been rejected either by the user or by calling `reject()` or `done()` with the `QDialog::Rejected` argument.

  Note that this signal is not emitted when hiding the dialog with `hide()` or setVisible(false). This includes deleting the dialog while it is visible.

See also:
  `finished()` , and `accepted()` .

Constructor Detail

### QDialog

    public QDialog(QWidget parent,
                   Qt.WindowType[] f)

  Constructs a dialog with parent `parent`.

  A dialog is always a top-level widget, but if it has a parent, its default location is centered on top of the parent. It will also share the parent's taskbar entry.

  The widget flags `f` are passed on to the `QWidget` constructor. If, for example, you don't want a What's This button in the title bar of the dialog, pass `Qt::WindowTitleHint` | `Qt::WindowSystemMenuHint` in `f`.

See also:
  `QWidget::setWindowFlags()`.

### QDialog

    public QDialog(QWidget parent)

  Constructs a dialog with parent `parent`.

  A dialog is always a top-level widget, but if it has a parent, its default location is centered on top of the parent. It will also share the parent's taskbar entry.

  The widget flags `f` are passed on to the `QWidget` constructor. If, for example, you don't want a What's This button in the title bar of the dialog, pass `Qt::WindowTitleHint` | `Qt::WindowSystemMenuHint` in `f`.

See also:
  `QWidget::setWindowFlags()`.

### QDialog

    public QDialog()

  Constructs a dialog with parent `parent`.

  A dialog is always a top-level widget, but if it has a parent, its default location is centered on top of the parent. It will also share the parent's taskbar entry.

  The widget flags `f` are passed on to the `QWidget` constructor. If, for example, you don't want a What's This button in the title bar of the dialog, pass `Qt::WindowTitleHint` | `Qt::WindowSystemMenuHint` in `f`.

See also:
  `QWidget::setWindowFlags()`.

### QDialog

    public QDialog(QWidget parent,
                   Qt.WindowFlags f)

  Constructs a dialog with parent `parent`.

  A dialog is always a top-level widget, but if it has a parent, its default location is centered on top of the parent. It will also share the parent's taskbar entry.

  The widget flags `f` are passed on to the `QWidget` constructor. If, for example, you don't want a What's This button in the title bar of the dialog, pass `Qt::WindowTitleHint` | `Qt::WindowSystemMenuHint` in `f`.

See also:
  `QWidget::setWindowFlags()`.

Method Detail

### exec

    public int exec()

  Shows the dialog as a `modal dialog`, blocking until the user closes it. The function returns a `DialogCode` result.

  If the dialog is `application modal` , users cannot interact with any other window in the same application until they close the dialog. If the dialog is `window modal` , only interaction with the parent window is blocked while the dialog is open.

  By default, the dialog is application modal.

See also:
  `show()`, `result()`, and setWindowModality().

### isSizeGripEnabled

    public final boolean isSizeGripEnabled()

  This property holds whether the size grip is enabled. A `QSizeGrip` is placed in the bottom-right corner of the dialog when this property is enabled. By default, the size grip is disabled.

### result

    public final int result()

  Returns the modal dialog's result code, `Accepted` or `Rejected`.

  Do not call this function if the dialog was constructed with the `Qt::WA_DeleteOnClose` attribute.

See also:
  `setResult()`.

### setModal

    public final void setModal(boolean modal)

  This property holds whether `show()` should pop up the dialog as modal or modeless. By default, this property is false and `show()` pops up the dialog as modeless. Setting his property to true is equivalent to setting `QWidget::windowModality` to `Qt::ApplicationModal` .

  `exec()` ignores the value of this property and always pops up the dialog as modal.

See also:
  `QWidget::windowModality`, `show()`, and `exec()`.

### setResult

    public final void setResult(int r)

  Sets the modal dialog's result code to `i`.

  Note: We recommend that you use one of the values defined by `QDialog::DialogCode` .

See also:
  `result()`.

### setSizeGripEnabled

    public final void setSizeGripEnabled(boolean arg__1)

  This property holds whether the size grip is enabled. A `QSizeGrip` is placed in the bottom-right corner of the dialog when this property is enabled. By default, the size grip is disabled.

### accept

    public void accept()

  Hides the modal dialog and sets the result code to `Accepted`.

See also:
  `reject()`, and `done()`.

### done

    public void done(int arg__1)

  Closes the dialog and sets its result code to `r`. If this dialog is shown with `exec()`, `done()` causes the local event loop to finish, and `exec()` to return `r`.

  As with `QWidget::close()`, `done()` deletes the dialog if the `Qt::WA_DeleteOnClose` flag is set. If the dialog is the application's main widget, the application terminates. If the dialog is the last window closed, the `QApplication::lastWindowClosed()` signal is emitted.

See also:
  `accept()`, `reject()`, `QApplication::activeWindow()`, and `QApplication::quit()`.

### reject

    public void reject()

  Hides the modal dialog and sets the result code to `Rejected`.

See also:
  `accept()`, and `done()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD